<template>
  <v-ons-page id="signUp">
    <v-ons-toolbar>
      <div class="center">
        <img src="@/assets/images/logo.svg" alt="J-Class" class="logo" />
      </div>
    </v-ons-toolbar>

    <div id="signUpInner">
      <div class="layout-form">
        <div class="form-group">
          <div class="content">
            <input
              :class="{ 'is-invalid': validation.hasError('name') }"
              type="text"
              placeholder="Masukan nama"
              class="form-control"
              v-model="name"
            />
          </div>
          <small id="emailHelp" class="form-text text-muted"
            ><span :class="{ 'text-danger': validation.hasError('name') }">{{
              validation.firstError("name")
            }}</span></small
          >
        </div>
        <div class="form-group">
          <div class="content">
            <input
              :class="{ 'is-invalid': validation.hasError('email') }"
              type="text"
              placeholder="Masukan Email"
              class="form-control"
              v-model="email"
            />
          </div>
          <small id="emailHelp" class="form-text text-muted"
            ><span :class="{ 'text-danger': validation.hasError('email') }">{{
              validation.firstError("email")
            }}</span></small
          >
        </div>
        <div class="form-group">
          <div class="input-group mb-3">
            <input
              :class="{ 'is-invalid': validation.hasError('password') }"
              type="password"
              placeholder="Masukan Kata sandi"
              class="form-control"
              v-model="password"
            />
          </div>
          <small id="passwordHelp" class="form-text text-muted"
            ><span
              :class="{ 'text-danger': validation.hasError('password') }"
              >{{ validation.firstError("password") }}</span
            ></small
          >
        </div>
        <div class="form-group">
          <div class="input-group mb-3">
            <input
              :class="{ 'is-invalid': validation.hasError('passwordCheck') }"
              type="password"
              placeholder="Konfirmasi kata sandi"
              class="form-control"
              v-model="passwordCheck"
            />
          </div>
          <small id="passwordHelp" class="form-text text-muted"
            ><span
              :class="{ 'text-danger': validation.hasError('passwordCheck') }"
              >{{ validation.firstError("passwordCheck") }}</span
            ></small
          >
        </div>

        <div class="form-group">
          <div class="input-group mb-3">
            <input
              type="text"
              placeholder="Alamat"
              class="form-control"
              v-model="address"
            />
          </div>
        </div>

        <div class="form-group">
          <div class="input-group mb-3">
            <textarea
              v-model="reason"
              class="form-control"
              placeholder="Alasan untuk bergabung"
            ></textarea>
          </div>
        </div>

        <div class="form-check form-group">
          <input
            type="checkbox"
            class="form-check-input"
            id="exampleCheck1"
            v-model="checkbox"
          />
          <label class="form-check-label" for="exampleCheck1"
            >Aku setuju dengan aturan & kebijakan privasinya</label
          >
          <small id="emailHelp" class="form-text text-muted"
            ><span
              :class="{ 'text-danger': validation.hasError('checkbox') }"
              >{{ validation.firstError("checkbox") }}</span
            ></small
          >
        </div>
        <div class="form-group">
          <div class="actions text-center">
            <button
              type="button"
              :disabled="!sendingData"
              class="btn btn-primary"
              @click="register()"
            >
              {{ sendingData === false ? "Memuat" : "Daftar" }}
            </button>
          </div>
        </div>
      </div>
    </div>

    <div class="container fixed-bottom">
      <div class="row text-center boxButton">
        <div class="col-lg btn btn-primary" @click="goToMasuk()">
          Klik Untuk Masuk
        </div>
      </div>
    </div>

    <v-ons-alert-dialog modifier="rowfooter" :visible.sync="errorServer">
      {{ message }}
      <template slot="footer">
        <v-ons-alert-dialog-button @click="errorServer = false"
          >Ok</v-ons-alert-dialog-button
        >
      </template>
    </v-ons-alert-dialog>
  </v-ons-page>
</template>
<script>
import Vue from "vue";
import { Promise } from "q";
import { resolve } from "url";
import authReg from "@/scripts/auth";
import logIn from "../auth/LogIn";

// Documentation, check at http://simple-vue-validator.magictek.cn/

import validatorVue from "simple-vue-validator";
const Validator = validatorVue.Validator;
Vue.use(validatorVue, {
  templates: {
    error: "Kesalahan",
    required: "Kolom ini harus diisi",
    email: "Email salah",
    minLength: "Minimal {0} huruf ditulis.",
    match: "Kata sandi tidak sama",
  },
});

export default {
  data() {
    return {
      name: "",
      email: "",
      password: "",
      passwordCheck: "",
      checkbox: false,
      errorServer: false,
      sendingData: true,
      message: "",
      reason: "",
      address: "",
    };
  },

  // Documentation, check at http://simple-vue-validator.magictek.cn/
  validators: {
    name: function (value) {
      return Validator.value(value).required().minLength(5);
    },
    email: function (value) {
      return Validator.value(value).required().minLength(5).email();
    },
    password: function (value) {
      return Validator.value(value).required().minLength(6);
    },
    "passwordCheck, password": function (passwordCheck, password) {
      if (this.submitted || this.validation.isTouched("passwordCheck")) {
        return Validator.value(passwordCheck)
          .required()
          .minLength(6)
          .match(password);
      }
    },
    checkbox: function (value) {
      return Validator.custom(function () {
        if (!Validator.isEmpty(value)) {
          if (value !== true) {
            return "Kamu Harus Setujuin Dulu";
          }
        }
      });
    },
  },
  methods: {
    goToMasuk() {
      this.$store.commit("navigator/specialPop", logIn);
    },
    register() {
      // memakai that agar this bisa terbaca setelah 'then'
      const that = this;

      this.$validate().then((success) => {
        if (success) {
          that.sendingData = false;
          // output message
          const registrationInsert = Promise.all(
            authReg.EmailRegistration(
              that.email,
              that.password,
              that.name,
              that.reason,
              that.address
            )
          );
          registrationInsert
            .then(function (user) {
              that.message = "Registrasi Berhasil! Silahkan masuk!";
            })
            .catch((error) => {
              that.message = error;
            })
            .finally(() => {
              that.errorServer = true;
              that.sendingData = true;
            });
        }
      });
    },
  },
};
</script>